package com.goldencode.hotel.oo;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.oo.lang.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.InternalEntry.Type;

/**
 * Business logic (converted to Java from the 4GL source code
 * in oo/Foo.cls).
 */
public class Foo
extends BaseObject
{
   @LegacySignature(type = Type.VARIABLE, name = "flag")
   private logical flag = UndoableFactory.logical(true);

   @LegacySignature(type = Type.PROPERTY, name = "test1")
   private integer test1 = TypeFactory.integer();

   @LegacySignature(type = Type.PROPERTY, name = "test2")
   private integer test2 = TypeFactory.integer();

   @LegacySignature(type = Type.PROPERTY, name = "test3")
   private integer test3 = TypeFactory.integer();

   @LegacySignature(type = Type.PROPERTY, name = "test4")
   private integer test4 = TypeFactory.integer();

   public void __oo_Foo_execute__()
   {
      externalProcedure(Foo.class, Foo.this, new Block((Body) () -> 
      {
         {
         }
      }));
   }

   @LegacySignature(type = Type.CONSTRUCTOR)
   public void __oo_Foo_constructor__()
   {
      internalProcedure(Foo.class, this, "__oo_Foo_constructor__", new Block((Body) () -> 
      {
         __lang_BaseObject_constructor__();
      }));
   }

   @LegacySignature(type = Type.GETTER, name = "test1", returns = "INTEGER")
   public integer getTest1()
   {
      return function(Foo.class, this, "test1", integer.class, new Block((Body) () -> 
      {
         storeReturnValue(0);
      }));
   }

   @LegacySignature(type = Type.GETTER, name = "test2", returns = "INTEGER")
   public integer getTest2()
   {
      return function(Foo.class, this, "test2", integer.class, new Block((Body) () -> 
      {
         if ((flag).booleanValue())
         {
            storeReturnValue(0);
            return;
         }
         
         storeReturnValue(14);
      }));
   }

   @LegacySignature(type = Type.GETTER, name = "test3", returns = "INTEGER")
   public integer getTest3()
   {
      return function(Foo.class, this, "test3", integer.class, new Block((Body) () -> 
      {
         repeat("loopLabel0", new Block((Body) () -> 
         {
            {
               returnNormal(0);
            }
         }));
      }));
   }

   @LegacySignature(type = Type.GETTER, name = "test4", returns = "INTEGER")
   public integer getTest4()
   {
      return function(Foo.class, this, "test4", integer.class, new Block((Body) () -> 
      {
         storeReturnValue(test4);
      }));
   }

   @LegacySignature(type = Type.METHOD, name = "m1", returns = "LOGICAL", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public logical m1(final integer _num)
   {
      integer num = TypeFactory.initInput(_num);
      
      return function(Foo.class, this, "m1", logical.class, new Block((Body) () -> 
      {
         storeReturnValue(false);
      }));
   }

   @LegacySignature(type = Type.METHOD, name = "m2", returns = "LOGICAL", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public logical m2(final integer _num)
   {
      integer num = TypeFactory.initInput(_num);
      
      return function(Foo.class, this, "m2", logical.class, new Block((Body) () -> 
      {
         if ((flag).booleanValue())
         {
            storeReturnValue(false);
            return;
         }
         
         storeReturnValue(true);
      }));
   }

   @LegacySignature(type = Type.METHOD, name = "m3", returns = "LOGICAL", parameters = 
   {
      @LegacyParameter(name = "num", type = "INTEGER", mode = "INPUT")
   })
   public logical m3(final integer _num)
   {
      integer num = TypeFactory.initInput(_num);
      
      return function(Foo.class, this, "m3", logical.class, new Block((Body) () -> 
      {
         repeat("loopLabel1", new Block((Body) () -> 
         {
            {
               returnNormal(false);
            }
         }));
      }));
   }
}
